#!/usr/bin/perl
#
#
#
# program: i-am-doh.pl
#
#  by loud-fat-bloke
#
#   www.loud-fat-bloke.co.uk
#
#
#
#  Description 
#
#  Had this idea back in 2000, wrote a paper on it, presented it at e-security show and
#  info sec
#
# finally i had to write this prototype proof of concept.
#
#
#  THe idea
#  --------
#
#    I noticed that most false posives were caused by attack strings pointed at a server that either
#    i-  didn't exist
#    ii- had service that was different to the vulnerable service ( i.e msadc pointed at appache)
#    iii-had a service that could have been vulnerable but wasn't
#
#   I also noticed that ids didn't take account of the value or the position of the ids sensor so
#   i developed a methodology to take account of these factors and include anomolous traffic detection 
#
#
#
#   What does it do
#   --------------
#
#
#  The whole thing works on priority escalation - alerts are escalated to the
#  "real q"  based on a number of criteria
#
#   reads in a snort log
#      and writes it to a validated alert q - the real q
#
#   criteria 1 - does a nessus report contain a cve, or bid reference that is in the rule   
#      - locates a nessus report on server in xlm
#      - strips the info out for the  port and protocol
#      -  checks to see if cve or bid in the report
#
#   criteria 2  - does the port exist
#  
#       - run nmap 
#       - check port is open
#       - store the os and service from nmap
#
#
#   criteria 3  - does the info in the bid match
#
#        - take the os and service from nmap                            
#        - see if this os / service  is in  BID (or snort,org or whitehats)
#   
#
#   if the criteria is met - a menu is banged out allowing a new nessus run or
#      adding the address.sid to an exclude file.
#
#    this exclude file allows snort to be educated
#
#
#  it also reduced data overload by filtering repeats.
#
#
#  Does it work
# ------------
#
#  Well it does for me but it does have some moments
#
#
#  it also  reduces the volume of alerts by about 60%
#
#
#
#
#
#
#
#
#######################################################################
########## configure site specific variables ##########################
#######################################################################
use  strict;
my($MY_ADDR)               =          11.2.94.88 ;  # Configure
#######################################################################
########## the address reange of hi-priority servers###################
########## all else will be rejected                ###################
#######################################################################
my($KEY_SERVERS) = "81\.2\.94" ;                   # Configure
	my($debugger) = "n" ;
#######################################################################
#######################################################################
#######################################################################
  my($linein) = "" ;
 my($line) = "";
 my($alert_class) = "";
 my($alert_priority)  = "";
my($alert_msg)="";
my($alert_mon) = "";
my($alert_day) = "";
my($alert_hour) ="";
my( $alert_min) = "";  
my($alert_sec) = "";
my($alert_sid) = "";
my($alert_saddr) = "" ;
my($alert_sport) = "" ;
my($alert_daddr) = "" ;
my($alert_dport) = "" ;
my($alert_prot) = "";  
my(@alert_xref) ="";
my( $nessus_vulnerable) = "" ;
my( $nessus_file) = "" ;
my( @nessus_out) = "" ;
my(  $testos) = "*";
my( $testproto) = "*";
my( $testservice) ="*" ;
my( $nmap) = " ";
my($nmapos) =  " ";
my($nmapproto) =  " ";
my($nmapservice) =   " " ;
my($ret,$rc) =  0 ;
 my($grepfiout) =  ""   ;
 my($msg) =  ""   ;
 my($response) =  ""   ;
 my($output) =  ""   ;
 my(@repbuf,$exclude);

	# 
#
require LWP::UserAgent;
	$debugger = "n" ;


my($snortfile) =  $ARGV[0] ;
my($outfile) =  $ARGV[1] ;
print $snortfile  ;
print $outfile ;

open(TAIL,"$snortfile") || die "thi si ufckde";
seek( TAIL,0,2);
#
open(OUT,"> $outfile");
#
#  read alert file
#
# 
@repbuf[0..100] =  " ";
#
while (1)
{
	#
	&init();
	# split log up into variables
	&readlog();
	#
	#
	########################################################################
	# we don't want to process port scans, bcast or anomalous proceess
	########################################################################
	 next   if ($line  =~  /spp_/ ) ;
	 next   if ($alert_daddr  eq "255.255.255.255"  ) ;
 	 next   if ($alert_prot  eq "ICMP"  ) ;
	#
	#
	#
	 	next if ($alert_saddr =~ /$MY_ADDR/ ) ;
	#
         next   unless  ($alert_daddr =~ /$KEY_SERVERS/ ) ;
# configure record types here #
#  
# These are what I use  
# NOT INTEREST IN RECOGNISANCE  
next if $alert_msg =~ /SCAN/ ;  
next if $alert_msg =~ /ICMP/ ;  
#  or POLICY  
next if $alert_msg =~ /POLICY/ ;  
next if $alert_msg =~ /PORN/ ;  
# or an old toot  
next if $alert_msg =~ /P2P/ ;  
next if $alert_msg =~ /NNTP/ ;  
next if $alert_msg =~ /MULTIMEDIA/ ;  
next if $alert_msg =~ /MISC/ ;  
next if $alert_msg =~ /INFO/ ;  
# This is what rocks my world  
# uncomment to reject
#next if $alert_msg =~ /SHELLCODE/ ;  
#next if $alert_msg =~ /ORACLE/ ;  
#next if $alert_msg =~ /X11/ ;  
#next if $alert_msg =~ /SMTP/ ;  
#next if $alert_msg =~ /WEB*/ ;  
#next if $alert_msg =~ /BACKDOOR/ ;  
#next if $alert_msg =~ /CHAT/ ;  
#next if $alert_msg =~ /DDOS/ ;  
#next if $alert_msg =~ /DNS/ ;  
#next if $alert_msg =~ /EXPLOIT/ ;  
#next if $alert_msg =~ /IMAP/ ;  
#next if $alert_msg =~ /MYSQL/ ;  
#next if $alert_msg =~ /POP2/ ;  
#next if $alert_msg =~ /POP3/ ;  
#next if $alert_msg =~ /SCAN/ ;  
#next if $alert_msg =~ /SMTP/ ;  
#next if $alert_msg =~ /RPC/ ;  
#next if $alert_msg =~ /VIRUS/ ;   
#next if $alert_msg =~ /TFTP/ ;  
#next if $alert_msg =~ /TELNET/ ;  
#next if $alert_msg =~ /SNMP/ ;   
#next if $alert_msg =~ /RSERVICES/ ;  
	#
	$exclude = $alert_daddr."-".$alert_sid;
	#
	########################################################################
	########reject if this dest address and sid appear in exclude file #####
	########################################################################
	$ret = 0;         
        &figrep("./exclude",$exclude);
	if ( $ret == 1 ) {
	next; 
        }
	########################################################################
	#
	#   reduce alerts by not repeating them  
	########################################################################
	#   but if more than # of the same alert to the same address
	#   stick out an alert
	########################################################################
	#
	my( @tmpcnt);
	if ( @tmpcnt = grep(/$exclude/ , @repbuf )  )
	{
		# even if the sid appears  store it 
	        push(@repbuf,$exclude);
        	shift(@repbuf);
	########################################################################
	#   but if more than # of the same alert to the same address
	#   stick out an alert & reset array
	########################################################################
	      if ( $#tmpcnt > 20 ) {
	         $msg = "'more than 10 reports of ($alert_msg $alert_sid   ) '"   ;
		 &spitlog($line);
                 &domenu();
                 # lazy  should only reset selectively by sid
		 @repbuf[0..100] =  " ";
	         }
	          next;
	} else {
	push(@repbuf,$exclude);
	shift(@repbuf);
	}
#
#

	&print_stuff()   if $debugger eq "y" ;
	########################################################################
	# Find your nessus output 
	#
	# Split it up by port and protocol
	#
	# check if contains the valid CVE or BID or NESSUS ID
	#
	#  IF SO YOU HAVE BEEN ATTACKED AND YOU ARE VULNERABLE!!!!!!!
	#                                             say no more
	########################################################################
	#
	$nessus_file = "./nessus_out/".$alert_daddr."/results.xml" ;
	########################################################################
	# build and check nessus output
	print $nessus_file if $debugger eq "y" ;
	#
	if ( -f $nessus_file ) {
		$alert_prot =~ tr/A-Z/a-z/ ;
		@nessus_out = ` ./ids/proc_nessus  $alert_prot $alert_dport $nessus_file` ;
		print @nessus_out   if $debugger eq "y" ;
	}
	########################################################################
	#
	#check to see if the  there is a cve in the alert and it appear in nessus output
	#
	########################################################################
	$msg = "";
	&check_nessus() ;
	#
        if ( $nessus_vulnerable eq  "y") {
		 &spitlog($line);
                 &domenu();
	          next;
         }
	########################################################################
	#
	#  We can't find a nessus scan or the nessus output doesn't include any
	#  CVE info but that doesn't mean we ain't vulnerable.  Now we have to
	#
	#   1. check if port alive and the platform its is on - easy nmap
	#   2. Identify what is behind the port - AMAP
	#   3. Try and get info from snort.org, Cve or bugtrack
	#   4. Make a determination based on this info
	#
	#
	########################################################################
        if ( $nessus_vulnerable ne  "y") {
 	 &donmap();
	  print "$nmapservice    $nmapos " if $debugger eq "y" ;
	       next if ( $ret == 0 ) ;
	       if ( $ret == 1 ) {
	       $msg = "'port open '";
      
	       if ( $alert_msg =~ m/WEB-/i) {
		       # web servers tend too be on al sorts of ports
		       &doamap();
		       if ( $ret == 1)
		       {
	               $nmapproto = "http"  ;

                       }
                   }

	       &snort_msg_helper ;
	  print "nmap service  $nmapservice nmap proto   $nmapproto os     $nmapos "  ;
	  print "$alert_msg \n ";
	  print "$testservice    $testproto   $testos "  ;

	  if ( $testos ne ".*" && $testproto ne ".*" && $testservice ne ".*")
	  {
	       if ( $nmapos =~  /$testos/i ) {
		       print " we got the right os " ;
	               if ( $nmapproto  =~  /$testproto/i ) {
		          print " we got the right proto " ;
	                  if ( $nmapservice  =~  /$testservice/i ) {
		              print " we got the right service  " ;
			      # we could do version doh
	         $msg = "'port open - os/ service /server match '";
		 &spitlog($line);
                 &domenu();
	          next;

                         }
                     }
                }
  
           }


	########################################################################
	###  Check BID for mention of service if found -- ######################
	###  TTHAT WILL DO DONKEY                       - ######################
	########################################################################
	## BUG track is best - cve and snort donot have good info 
	########################################################################
                  for   ( @alert_xref ) {
		       if ( /BID/ )   {    # only do bugtrack
                       &getpage( $_  );
		          if ( $output =~ /$nmapservice/i  )  {
			       # the bugtrack page refers to service
	                       $msg = "'port open and is running the same service that bugtrack says is vulnerable '";
		 &spitlog($line);
                 &domenu();
	          next;
		             }   
			     #
		          if ( $output =~ /$nmapproto/i &&  $output =~ /$nmapos/i   )  {
				  # the bugtrack page refers to proto and os
			       $msg = "'port open and is running the same proto and os that bugtrack says is vulnerable '";
		 &spitlog($line);
                 &domenu();
	          next;
		             }   
			     #
		        }

		   }  
		   # lets go to snort and see if there is any systems info
		   # dont no why anyone would document a rule and not fill in the bit
		   # about vulnerable systems but 90% havent any
		   
		   &getpage( "http://www.snort.org/snort-db/sid.html?sid=$alert_sid"  );
		          if ( $output =~ /$nmapservice/i  )  {
			       # the bugtrack page refers to service
			       $msg = "'port open and is running the same service that snort.org says is vulnerable '";
		 &spitlog($line);
                 &domenu();
	          next;
		             }   


			     # by the time you get here yo know the prot is open
			     # and that is all  - if that is enough uncomment the following lines
			     #
			     #
			     #&spitlog($line);
			     #&domenu();
			     # next;
	        }
         }
#
}

	exit ;

########################################################################
# stick up a menu                                                    ###
########################################################################
sub domenu() {
	foreach (1..3)
	{
	system("gmessage -buttons 'just leave-ignore':1,'add this to excluded SID list':2,'run nessus':3,'attacks from this bad boy':4,'send abuse email':5  -timeout 30 $alert_msg  $msg");
	$rc = $?;
#  now                            
	if ( $rc  == 256 )
	{
	return	;
	}
#  now exclude the sid and address
	if ( $rc  == 512 )
	{
         open(EXCLUDE,">>./exclude");
		print EXCLUDE     "$exclude \n";
		close  EXCLUDE         ; 
	}
#  now run nessus          
	if ( $rc  == 768 )
	{
        #		print "run nessus" x 11 ;
	system("./ids/sched_nessuss $alert_daddr"); 
	}
#  now run gless           
	if ( $rc  == 1024)
	{
        #		print "run nessus" x 11 ;
	system("grep $alert_saddr $snortfile | gless "); 
	}
#  now run modified  get contact.pl  
	if ( $rc  == 1280)
	{
        #		print "run nessus" x 11 ;
	system("getcontact.pl $alert_saddr  "); 
	}
#        
  }
}
	

	
########################################################################
#
sub print_stuff (){
print  "alert_msg $alert_msg";

print  " alert date  $alert_day/$alert_mon time $alert_hour: $alert_sec \n";
print	"alert_sid $alert_sid \n";
print	"alert_saddr $alert_saddr \n" ;
print	"alert_sport $alert_sport \n" ;
print	"alert_daddr $alert_daddr \n" ;
print	"alert_dport $alert_dport \n alert_prot $alert_prot  \n  ";  
print "reference @alert_xref " ;
}
########################################################################
sub init { 
 $line = "";
	# 
        $alert_class = "";
 	$alert_priority  = "";
	$alert_msg="";
	$alert_mon = "";
	$alert_day = "";
	$alert_hour ="";
        $alert_min = "";  
	$alert_sec = "";
	$alert_sid = "";
	$alert_saddr = "" ;
	$alert_sport = "" ;
	$alert_daddr = "" ;
	$alert_dport = "" ;
	$alert_prot = "";  
	@alert_xref ="";
        $nessus_vulnerable = "" ;
         $testos = ".*";
	 $testproto = ".*";
	 $testservice =".*" ;
         $nmap = " ";
	$nmapos =  " ";
	$nmapservice =   " " ;

  }
	# 
########################################################################
# routine to look for info in nessus output
#  TODO: only checks for BID & CVE needs to check nessus plug in 
########################################################################
sub check_nessus() {
       my( $cve ) = "";
       my( $BID ) = "";
if ( grep (/cvename/ , @alert_xref ) )
{
       foreach $cve  ( @alert_xref) {
         next unless  $cve =~ /cvename/ ;
	       $cve =~ s/^.*name=(.*)\b/\1/;
	       print "cve $cve "  if $debugger eq "y" ;
               if ( grep (/$cve/ , @nessus_out ) ) {
		       $msg =  "you are vulnerable according to your last nessus report  -  cve $cve "  ;
		       $nessus_vulnerable = "y" ;
		       return;
	       }
       }
  # 
}
#
#
if ( grep (/BID/ , @alert_xref ) )
{
       foreach $BID  ( @alert_xref) {
         next unless  $BID =~ /BID\// ;
	       $BID =~ s/^.*\/BID\/(\d+)/\1/;
	       print "BID $BID "  if $debugger eq "y" ;
               if ( grep (/BID:.*$BID/ , @nessus_out ) ) {
		       $msg =  "you are vulnerable according to your last nessus report -  BID $BID "  ;
		       $nessus_vulnerable = "y" ;
		       return;
	       }
       }
  # 
}
#
#
}


#
#
########################################################################
# routine to do a grep                            
########################################################################
sub figrep {
	my($infi,$pattern) = @_;
	$ret = 0;
open(INF,$infi);
#
#  read file
#
while (<INF>)
{
	if (/$pattern/)
	{
	$grepfiout =  $_   ;
	print $_   if $debugger eq "y" ;
	$ret = 1;
        last;
          }
}
close INF;
 return $ret ;
}
#
#
#
#
#
#
########################################################################
# write out a log of non-false positives                               #
########################################################################

sub spitlog {
	my($pants) = @_;
	print OUT $pants;

}
########################################################################
##  read an alert record  ##############################################
########################################################################
sub readlog {
# 
my($tmp)="";
  $line = "" ;
  $linein = "" ;
while (1) {
  # if the line is blank, leave an make fields 
  &readline ;
  $line = $line . $linein;
    chop($linein);
  last  if $linein eq "";
  }
  # 
if ( $line  =~ m/\[\*\*\]\s*\[\d+:(\d+):\d+\](.*)\[\*\*\]/ ) {
	$alert_sid=$1;
	$alert_msg=$2;
}
################################################################################
      if ( $line =~ m/\[Classification\:(.*)\]\s \[Priority\:\s(\d+)\]/ox) {
        $alert_class = $1;
 	$alert_priority  = $2;
      }
################################################################################
################################################################################
      if ( $line =~ m/(\d+)\/(\d+)\-(\d+)\:(\d+)\:(\d+)\.(\d+)\s/ox)
	 {
        $alert_mon = $1; 
	$alert_day = $2;  
	$alert_hour = $3; 
        $alert_min = $4;  
	$alert_sec = $5;  
      }
################################################################################
      if ( $line =~ m/\s([\d\.]+)[\:]*([\d]*)\s[\-\>]+\s([\d\.]+)[\:]*([\d]*)\s(\w+)/ox) {
        $alert_saddr = $1; 
        $alert_sport = $2;
	$alert_daddr = $3;
	$alert_dport = $4; 
	$alert_prot = $5;  
      }
################################################################################
      if (  $line  =~ m/(\[Xref.*)/)  {
	        $tmp       =  $1  ;
	       $tmp        =~ s/\]//g ;
	       @alert_xref = split  (/\[Xref\s=>/,$tmp ) ;
	      print  @alert_xref if $debugger eq "y" ;
	      # 
      }
 }
################################################################################
##  run nmap get service and os ################################################
########################################################################

sub donmap() {
		my($flag) = "T";
	$ret =  0 ;
         $nmap = " ";
	$nmapos =  " ";
	$nmapservice =   " " ;
#
	if ( $alert_prot =~ /TCP/i ) {
		$flag = "T";
	}
	if ( $alert_prot =~ /UDP/i ) {
		$flag = "U";
	}
	 $nmap = "/usr/local/bin/nmap -s ".$flag." -sV -O   -p".$alert_dport." -n ".$alert_daddr   ;
	# system("$nmap      "); 
	print    "$nmap      " ; 
	#
	my(@nmapout) = `$nmap`; 
	print $?  ;
	print @nmapout if $debugger eq "y" ;
	foreach (@nmapout)    {
	if (/$alert_dport\/.*open/) {
	print $_   if $debugger eq "y" ;
	$nmapos =  $_;
	# nmap sticks ? in some places 
	$nmapos =~  s/\?//  ;
	$ret =  1 ;
	$nmapservice =   $nmapos ;
	$nmapproto   =   $nmapos ;
	# $nmapservice =~ s/.*open\s*\w+\b*//  ;
	$nmapproto   =~ s/.*open\s*(\w+)\b*/\1/  ;
	$nmapservice =~ s/.*$nmapproto\b*/  /  ;
	# get first word
	$nmapservice =~ s/\s*(\w+)/\1 /  ;
        }
	#
	if (/Running:(.*)/){
	$nmapos = $1;
	# $nmapos =~ s/\s*(\w+)\s*/\1/  ;
        }
	#
}
}
################################################################################
#
#****************************** getpage *********************
sub getpage  {
my($url) = @_;
my($ua) = LWP::UserAgent->new;
my($whichserver) = "";
$output = "";
my($request) = HTTP::Request->new('GET',$url);
#
$response = $ua->request($request);

if ($response->is_success) {
     $output = $response->content;
     print $output   if $debugger eq "y" ;
     }
}
################################################################################
#
#****************************** readline *********************


sub readline  {
while (1)
{
	if (eof(TAIL) )
	{
		sleep(10);
	} else
	{
		$linein=<TAIL> ;
		return;
	}
}
}
################################################################################
#
#****************************** snort mesg helper *********************

sub snort_msg_helper {
	$ret=1 ;
	# order is signifcant
      if ( $alert_msg =~ m/FTP EXPLOIT wu-ftpd/i) {
         $testos = ".*" ;
	 $testproto = "ftp*";
	 $testservice ="wu-ftp" ;
return;
 }
 #
      if ( $alert_msg =~ m/DNS EXPLOIT/i) {
         $testos = ".*" ;
	 $testproto = "domain";
	 $testservice ="[bind|named]" ;
return;
 }
 #
      if ( $alert_msg =~ m/DNS named/i) {
         $testos = ".*" ;  # could this say !windows
	 $testproto = "domain";
	 $testservice ="(bind|named)" ;
return;
 }
 #
 #
      if ( $alert_msg =~ m/EXPLOIT X86\s(\w+)/i) {
         $testos = $1 ;
	 $testproto = ".*";
	 $testservice =".*" ;
return;
 }

      if ( $alert_msg =~ m/EXPLOIT ([AIX|SPARC|HP-UX])/i) {
         $testos = $1 ;
	 $testproto = ".*";
	 $testservice =".*" ;
return;
 }
 #   an SMTP sendmail  problem
      if ( $alert_msg =~ m/SMTP Sendmail/i) {
         $testos = ".*" ;
	 $testproto = "SMTP";
	 $testservice ="SENDMAIL" ;
return;
 }
 #   an netbios problem
      if ( $alert_msg =~ m/NETBIOS Samba/i) {
         $testos = ".*" ;
	 $testproto = "netbios-ssn";
	 $testservice =".*" ;
return;
 }
 #   an netbios problem 
      if ( $alert_msg =~ m/NETBIOS/i) {
         $testos = "windows" ;
	 $testproto = "netbios-ssn";
	 $testservice =".*" ;
return;
 }

 #  Not really an sql problem at all
      if ( $alert_msg =~ m/MS-SQL\/SMB/i) {
         $testos = "windows" ;
	 $testproto = "netbios-ssn";
	 $testservice =".*" ;
return;
 }
 #
      if ( $alert_msg =~ m/MS-SQL/i) {
         $testos = "windows" ;
	 $testproto = "ms-sql";
	 $testservice ="sql" ;
return;
 }
 #
      if ( $alert_msg =~ m/WEB-IIS/i) {
         $testos = "windows" ;   #could be on another platform
	 $testproto = "htt*";
	 $testservice ="INFORMATION SERVER" ;
return;
 }
	 
      if ( $alert_msg =~ m/WEB-/i) {
         $testos = ".*" ;
	 $testproto = "htt*";
	 $testservice =".*" ;
return;
 }
# 
if (   $alert_msg =~ /SMTP/i  ) {
&setcriteria (".*" , "SMTP", ".*" );
return;
}

if (  $alert_msg =~ /DNS/  ) {  
&setcriteria   (".*" , "domain", ".*" );
return;
 }

if (  $alert_msg =~ /IMAP/  ) {  
&setcriteria   (".*" , "imap*", ".*" );
return;
 }


if (  $alert_msg =~ /POP2/  ) {  
&setcriteria   (".*" , "pop*", ".*" );
return;
 }


if (  $alert_msg =~ /POP3/  ) {  
&setcriteria   (".*" , "pop*", ".*" );
return;
 }


if (  $alert_msg =~ /TFTP/  ) {  
&setcriteria   (".*" , "tftp", ".*" );
return;
 }


if (  $alert_msg =~ /TELNET/  ) {  
&setcriteria   (".*" , "telne*", ".*" );
return;
 }


if (  $alert_msg =~ /SNMP/  ) {   
&setcriteria   (".*" , "snm*", ".*" );
return;
 }

	$ret=0 ; 

 }
 ##########################################################################

  
sub setcriteria   
{  
my (  $inos, $inproto, $inservice ) = @_;  
if ( $testos eq ".*" )  
{  
$testos  =   $inos;  
}  
  
if ( $testproto eq ".*" )  
{  
$testproto  =   $inproto;  
}  
  
if ( $testservice eq ".*" )  
{  
$testservice  =   $inservice;  
}  
}  
	
########### do amap ########################
sub doamap() {
	$ret =  0 ;
#
        my ($amap) = "/usr/local/bin/amap  ".$alert_daddr . "   ".$alert_dport   ;
	# system("$nmap      "); 
	#
	my(@amapout) = `$amap`; 
	print $?  ;
	print @amapout if $debugger eq "y" ;
	foreach (@amapout)    {
	if (/matches.*htt*/) {
	$ret =  1 ;
 }
}
}

